package com.loafle.overflow.central.module.domain.dao;



import com.loafle.overflow.model.domain.Domain;
import com.loafle.overflow.model.domain.DomainMember;
import com.loafle.overflow.model.member.Member;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by root on 17. 6. 23.
 */
@Repository
public interface DomainMemberDAO extends JpaRepository<DomainMember, Long> {

    @Query("SELECT dm from DomainMember dm where dm.member.email = (:email)")
    DomainMember findByMemberEmail(@Param("email") String email);
    
    @Query("SELECT dm.domain from DomainMember dm where dm.member = (:member)")
    Domain findDomainByMember(@Param("member") Member member);

    @Query("SELECT dm.member from DomainMember dm where dm.domain = (:domain)")
    List<Member> findAllMemberByDomain(@Param("domain") Domain domain);

    @Query("SELECT dm.member from DomainMember dm where dm.domain.id = (:domainID)")
    List<Member> findAllMemberByDomainID(@Param("domainID") long domainID);
}
