package com.loafle.overflow.central.module.infra.service;

import com.loafle.overflow.central.spring.AppConfigTest;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.infra.InfraHost;
import com.loafle.overflow.model.infra.InfraOS;
import com.loafle.overflow.model.meta.MetaInfraType;
import com.loafle.overflow.service.central.infra.InfraHostService;

import org.codehaus.jackson.map.ObjectMapper;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;


/**
 * Created by snoop on 17. 7. 27.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class InfraHostServiceTest {

    @Autowired
    private InfraHostService infraHostService;

    @Test
//    @Ignore
    public void regist() throws Exception {

        InfraHost infraHost = new InfraHost();

        infraHost.setMac(8796753988883L);
        infraHost.setIp(3232235980L);

        InfraOS infraOS = new InfraOS();
        infraOS.setId(2);

        infraHost.setOs(infraOS);

        MetaInfraType metaInfraType = new MetaInfraType();
        metaInfraType.setId(2);


        this.infraHostService.regist(infraHost);

        Assert.assertNotEquals(infraHost.getId(), 0 );

    }

    @Test
    public void read() throws Exception {

        InfraHost infraHost = this.infraHostService.read(1);

        ObjectMapper objectMapper = new ObjectMapper();
        String json  = objectMapper.writeValueAsString(infraHost);

        System.out.println(json);

    }

    @Test
    public void readByIp() {

        InfraHost infraHost;
		try {
            infraHost = this.infraHostService.readByIp(3232235980L);
            Assert.assertNotEquals(infraHost, null);
		} catch (OverflowException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


    }

}